/**
  *  \file planetscentral/net/connstream.h
  */
#ifndef C2SERVER_PLANETSCENTRAL_NET_CONNSTREAM_H
#define C2SERVER_PLANETSCENTRAL_NET_CONNSTREAM_H

#include <ios>
#include <ostream>
#include "planetscentral/dbclient/connection.h"

/** Stream buffer writing into a connection. */
class ConnectionStreambuf : public std::streambuf {
    Connection& conn;
    char buffer[4096];
 public:
    ConnectionStreambuf(Connection& conn);
    int overflow(int);
    int sync();
};

/** Stream writing into a connection. This just makes the ConnectionStreambuf
    a little easier to use. */
class ConnectionStream : public std::ostream {
    ConnectionStreambuf sb;
 public:
    ConnectionStream(Connection& conn);

    ~ConnectionStream();
};

#endif
